#include "stdafx.h"

#include "capp.h"

void	CApp::MainThread() {

	GetDraw()->SetDisplay();

	CFPSTimer timer;
	timer.SetFPS(10);

	//	CvɂiIƂɁÃEBhDׂĕj
	SetMainApp(true);

	//------- soundĐ̃Tv -----------

	//	1.mp3Xg[ĐōĐTv
	CSound mysound;					//	CSoundp(̎̂smart_ptr<ISound>
	mysound.Load("sound.mp3");		//	t@Cw肵ēǂݍ
	mysound->Play();				//	ĐȂ
	//	̏ꍇAmp3܂ɒstatic bufferɓȂ̂ŁA
	//	ĐłȂ\B(6M炢MP3t@C͂܂ĐȂ)
	mysound->Stop();
	//	Đ~߂ɂStopĂяo

	//	2.Xg[Đ̏ꍇ
	soundFactory_.SetStreamPlay(true);
	mysound.Load("sound.mp3");		//	t@Cw肵ēǂݍ
	mysound->Play();				//	ĐȂ
	//	Xg[ĐȂ̂ōĐł(Ǝv)
	mysound->Stop();
	//	Đ~߂ɂStopĂяo

	//	3.SoundLoaderpčĐꍇ
	CSoundLoader loader;
	loader.SetStreamPlay(true);
	//	Xg[ĐǂACSoundFactoryIɎw肷邱Ƃo
	//	(̃oĂяoĐݒ肵ꍇACSoundFactoryŎw肵̂D悳)

	loader.SetSoundFactory(smart_ptr<ISoundFactory>(&soundFactory_,false));
	//	SoundFactoryݒ肵Ă
	loader.Set("sound.cfg.txt",true);
	//	t@Cݒt@Cǂݍ܂
	string s = loader.GetFileName(3);
	//	ԍw肵ăt@C擾ł@\
	//	CDbg().Out(s);
	CSound sound = loader.GetSound(7);
	//	GetSound΁AISoundhNX̃CX^XA
	//	t@C̓ǂݍ݂sȂ
	sound->Play();
	//	Play
	sound->Stop();
	//	~
	sound->Close();
	//	
	sound = loader.GetSound(3);
	//	Sound擾
	//	ȉAāASound낢ĐłB


	//	4.SELoaderpꍇ
	{
	CSELoader loader;

	CDefaultCacheStaleListener* listener = new CDefaultCacheStaleListener;
	listener->SetMax(10); // 10zēǂݍ񂾏ꍇAÂ̂Ă
	loader.SetCacheStaleListener(smart_ptr<ICacheStaleListener>(listener));

	loader.SetSoundFactory(smart_ptr<ISoundFactory>(&soundFactory_,false));
	loader.Set("se.cfg.txt",true);

	CSound sound = loader.GetSound(10);
	sound->Play();
	}

	//	5.PlaneLoaderpꍇ
	CPlaneLoader planeloader;
	planeloader.Set("plane.cfg.txt",true);

	while (IsThreadValid()){
		ISurface* pSecondary = GetDraw()->GetSecondary();

		//	PlaneLoaderv[Ă`悷ꍇ
		CPlane plane = planeloader.GetPlane(5);
		pSecondary->BltFast(plane,0,0);

		GetDraw()->OnDraw();

		timer.WaitFrame();
	}
}

//	ꂪmain windoŵ߂̃NXB
class CAppMainWindow : public CAppBase {	//	AvP[VNXh
	virtual void MainThread(){			   //  ꂪ[J[Xbh
		CApp().Start();
	}
};

//	킸ƒmꂽWinMain
int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	{
		/*
		{	//	G[Ot@Cɏo͂̂I
			CTextOutputStreamFile* p = new CTextOutputStreamFile;
			p->SetFileName("Error.txt");
			Err.SelectDevice(smart_ptr<ITextOutputStream>(p));
		}
		*/

		CSingleApp sapp;
		//	ɏȂƁAXbhN
		//	CAppInitializer̃fXgN^őSXbh̏I҂悤ȏꍇ
		//	CSingleApp̃fXgN^ɋNĂ܂̂ŁA܂̂DD

		CAppInitializer init(hInstance,hPrevInstance,lpCmdLine,nCmdShow);
		//	KĂ

		if (sapp.IsValid()) {
			CThreadManager::CreateThread(new CAppMainWindow);
			//	Œ`C̃EBhD쐬
//			CThreadManager::CreateThread(new CAppMainWindow);
//			ƁAEBhD̂

		}
		//	CAppInitializerXR[vAEĝÂƂ
		//	ׂẴXbh̏I҂ƂɂȂ
	}
	return 0;
}
